Repository (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.stereotype

## Annotation Type Repository

-     @Target(value=TYPE)
      @Retention(value=RUNTIME)
      @Documented
      @Component
      public @interface Repository

  Indicates that an annotated class is a "Repository", originally defined by Domain-Driven Design (Evans, 2003) as "a mechanism for encapsulating storage, retrieval, and search behavior which emulates a collection of objects".

  Teams implementing traditional J2EE patterns such as "Data Access Object" may also apply this stereotype to DAO classes, though care should be taken to understand the distinction between Data Access Object and DDD-style repositories before doing so. This annotation is a general-purpose stereotype and individual teams may narrow their semantics and use as appropriate.

  A class thus annotated is eligible for Spring `DataAccessException` translation when used in conjunction with a `PersistenceExceptionTranslationPostProcessor`. The annotated class is also clarified as to its role in the overall application architecture for the purpose of tooling, aspects, etc.

  As of Spring 2.5, this annotation also serves as a specialization of `@Component`, allowing for implementation classes to be autodetected through classpath scanning.

  Since:
    2.0
  Author:
    Rod Johnson, Juergen Hoeller
  See Also:
    `Component`, `Service`, `DataAccessException`, `PersistenceExceptionTranslationPostProcessor`

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `String` | `value` The value may indicate a suggestion for a logical component name, to be turned into a Spring bean in case of an autodetected component.

- - ### Element Detail

    - #### value

          public abstract String value

      The value may indicate a suggestion for a logical component name, to be turned into a Spring bean in case of an autodetected component.
      Returns:
        the suggested component name, if any
      Default:
        ""